/**
 * 
 */
package com.wieseke.cptk.common.action;

import org.eclipse.jface.util.IPropertyChangeListener;
import org.eclipse.jface.viewers.ISelection;
import org.eclipse.ui.ISelectionListener;
import org.eclipse.ui.IWorkbenchPart;

import com.wieseke.cptk.common.selection.CophylogenyViewerSelection;
import com.wieseke.cptk.common.viewer.CophylogenyViewer;

/**
 * @author Nicolas Wieseke
 * 
 */
public abstract class CommonPropertyListenerAction extends CommonAction
		implements ISelectionListener {

	/**
	 * listener for the property change event
	 */
	protected IPropertyChangeListener propertyChangeListener;

	/**
	 * constructor
	 * 
	 * @param text
	 */
	public CommonPropertyListenerAction(String text) {
		super(text);
		setEnabled(false);
	}

	/**
	 * constructor
	 * 
	 * @param text
	 * @param style
	 */
	public CommonPropertyListenerAction(String text, int style) {
		super(text, style);
		setEnabled(false);
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @seeorg.eclipse.ui.ISelectionListener#selectionChanged(org.eclipse.ui.
	 * IWorkbenchPart, org.eclipse.jface.viewers.ISelection)
	 */
	
	public void selectionChanged(IWorkbenchPart part, ISelection selection) {
		this.part = part;
		if (!selection.isEmpty()
				&& selection instanceof CophylogenyViewerSelection) {
			CophylogenyViewer viewer = ((CophylogenyViewerSelection) selection)
					.getCophylogenyViewer();
			if (!viewer.equals(this.viewer)) {
				if (this.viewer != null) {
					this.viewer
							.removePropertyChangeListener(this.propertyChangeListener);
				}
				this.viewer = viewer;
				this.viewer
						.addPropertyChangeListener(this.propertyChangeListener);
				setChecked(this.viewer.isAdjustChildNode());
			}
			this.viewer = ((CophylogenyViewerSelection) selection)
					.getCophylogenyViewer();
		}
	}
}
