/**
 * 
 */
package com.wieseke.cptk.common.action;

import org.eclipse.jface.util.IPropertyChangeListener;
import org.eclipse.jface.util.PropertyChangeEvent;
import org.eclipse.jface.viewers.ISelection;
import org.eclipse.ui.IWorkbenchPart;

import com.wieseke.cptk.common.constants.ViewerConstants;

/**
 * @author Nicolas Wieseke
 * 
 */
public class SelectShowHostLabelsAction extends CommonPropertyListenerAction {

	/**
	 * default constructor
	 * 
	 * @param text
	 */
	public SelectShowHostLabelsAction(String text) {
		super(text, AS_CHECK_BOX);
		this.propertyChangeListener = new IPropertyChangeListener() {
			/*
			 * (non-Javadoc)
			 * 
			 * @see
			 * org.eclipse.jface.util.IPropertyChangeListener#propertyChange
			 * (org.eclipse.jface.util.PropertyChangeEvent)
			 */
			
			public void propertyChange(PropertyChangeEvent event) {
				if (event.getProperty().equals(
						ViewerConstants.PROPERTY_SHOW_HOST_LABELS)
						&& !event.getNewValue().equals(event.getOldValue())) {
					setChecked((Boolean) event.getNewValue());
				}
			}
		};
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see org.eclipse.jface.action.Action#run()
	 */
	
	public void run() {
		if (this.viewer != null) {
			this.viewer.setShowHostLabels(this.isChecked());
		}
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see
	 * com.wieseke.cptk.common.action.CommonAction#selectionChanged(org.eclipse
	 * .ui.IWorkbenchPart, org.eclipse.jface.viewers.ISelection)
	 */
	
	public void selectionChanged(IWorkbenchPart part, ISelection selection) {
		super.selectionChanged(part, selection);
		if (this.viewer != null)
			setChecked(this.viewer.isShowHostLabels());
	}
}