/**
 * 
 */
package com.wieseke.cptk.common.provider;

import java.beans.PropertyChangeEvent;
import java.beans.PropertyChangeListener;

import org.eclipse.jface.viewers.IStructuredContentProvider;
import org.eclipse.jface.viewers.Viewer;

import com.wieseke.cptk.common.model.PropertiesElement;
import com.wieseke.cptk.input.model.InputNodeProperties;
import com.wieseke.cptk.output.model.OutputNodeProperties;

/**
 * @author Nic
 * 
 */
public class NodePropertiesContentProvider implements
		IStructuredContentProvider, PropertyChangeListener {

	private final Viewer viewer;

	public NodePropertiesContentProvider(Viewer viewer) {
		this.viewer = viewer;
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see
	 * org.eclipse.jface.viewers.IStructuredContentProvider#getElements(java
	 * .lang.Object)
	 */
	
	public Object[] getElements(Object inputElement) {
		if (inputElement instanceof InputNodeProperties) {
			InputNodeProperties nodeInfo = (InputNodeProperties) inputElement;
			PropertiesElement[] content = new PropertiesElement[5];
			content[0] = new PropertiesElement("node type", nodeInfo
					.getNodeType());
			content[1] = new PropertiesElement("label", nodeInfo.getLabel());
			content[2] = new PropertiesElement("rank", nodeInfo.getRank());
			content[3] = new PropertiesElement("x position", nodeInfo.getPosX());
			content[4] = new PropertiesElement("y position", nodeInfo.getPosY());
			return content;
		}
		if (inputElement instanceof OutputNodeProperties) {
			OutputNodeProperties nodeInfo = (OutputNodeProperties) inputElement;
			PropertiesElement[] content = new PropertiesElement[13];
			content[0] = new PropertiesElement("node type", nodeInfo
					.getNodeType());
			content[1] = new PropertiesElement("label", nodeInfo.getLabel());
			content[2] = new PropertiesElement("rank", nodeInfo.getRank());
			content[3] = new PropertiesElement("host mapping", nodeInfo
					.getHostMapping());
			content[4] = new PropertiesElement("cost", nodeInfo.getCost());
			content[5] = new PropertiesElement("cospeciations", nodeInfo
					.getCospeciations());
			content[6] = new PropertiesElement("sortings", nodeInfo
					.getSortings());
			content[7] = new PropertiesElement("duplications", nodeInfo
					.getDuplications());
			content[8] = new PropertiesElement("host switches", nodeInfo
					.getHostswitches());
			content[9] = new PropertiesElement("direct cospeciations", nodeInfo
					.getCospeciationsSingle());
			content[10] = new PropertiesElement("direct sortings", nodeInfo
					.getSortingsSingle());
			content[11] = new PropertiesElement("direct duplications", nodeInfo
					.getDuplicationsSingle());
			content[12] = new PropertiesElement("direct host switches",
					nodeInfo.getHostswitchesSingle());
			return content;
		}
		return null;
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see org.eclipse.jface.viewers.IContentProvider#dispose()
	 */
	
	public void dispose() {

	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see
	 * org.eclipse.jface.viewers.IContentProvider#inputChanged(org.eclipse.jface
	 * .viewers.Viewer, java.lang.Object, java.lang.Object)
	 */
	
	public void inputChanged(Viewer viewer, Object oldInput, Object newInput) {

	}

	
	public void propertyChange(PropertyChangeEvent arg0) {
		this.viewer.refresh();
	}

}
