/**
 * 
 */
package com.wieseke.cptk.common.selection;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

import org.eclipse.jface.viewers.IStructuredSelection;

import com.wieseke.cptk.common.viewer.CophylogenyViewer;

/**
 * @author Nic
 * 
 */
public class CophylogenyViewerSelection implements IStructuredSelection {

	private CophylogenyViewer cophylogenyViewer;

	public CophylogenyViewerSelection(CophylogenyViewer cophylogenyViewer) {
		this.cophylogenyViewer = cophylogenyViewer;
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see org.eclipse.jface.viewers.ISelection#isEmpty()
	 */
	
	public boolean isEmpty() {
		return (cophylogenyViewer == null);
	}

	/**
	 * @return the cophylogenyViewer
	 */
	public CophylogenyViewer getCophylogenyViewer() {
		return cophylogenyViewer;
	}

	/**
	 * @param cophylogenyViewer
	 *            the cophylogenyViewer to set
	 */
	public void setCophylogenyViewer(CophylogenyViewer cophylogenyViewer) {
		this.cophylogenyViewer = cophylogenyViewer;
	}

	
	public Object getFirstElement() {
		return this.cophylogenyViewer;
	}

	
	public Iterator<?> iterator() {
		Iterator<CophylogenyViewer> iterator = new Iterator<CophylogenyViewer>() {
			boolean hasNext = true;

			
			public boolean hasNext() {
				return hasNext;
			}

			
			public CophylogenyViewer next() {
				if (hasNext) {
					hasNext = false;
					return CophylogenyViewerSelection.this.cophylogenyViewer;
				}
				return null;
			}

			
			public void remove() {
				hasNext = false;
			}
		};
		return iterator;
	}

	
	public int size() {
		return this.cophylogenyViewer == null ? 0 : 1;
	}

	
	public Object[] toArray() {
		CophylogenyViewer[] result = { this.cophylogenyViewer };
		return result;
	}

	
	public List<?> toList() {
		List<CophylogenyViewer> result = new ArrayList<CophylogenyViewer>();
		result.add(this.cophylogenyViewer);
		return result;
	}
}
