/**
 * 
 */
package com.wieseke.cptk.common.util;

import org.eclipse.swt.graphics.Point;
import org.eclipse.swt.graphics.Rectangle;

/**
 * @author Nicolas Wieseke
 * 
 */
public class Scaling {

	/**
	 * converts a rectangle from the scaled coordinate system to the normalized
	 * coordinate system
	 * 
	 * @param rectangle
	 * @return the converted rectangle
	 */
	public static Rectangle convertFromScaled(Rectangle rectangle, double scaleFactor) {
		Rectangle newPoint = new Rectangle(convertFromScaled(rectangle.x, scaleFactor), convertFromScaled(rectangle.y,
				scaleFactor), convertFromScaled(rectangle.width, scaleFactor), convertFromScaled(rectangle.height,
				scaleFactor));
		return newPoint;
	}

	/**
	 * converts a rectangle from the normalized coordinate system to the scaled
	 * coordinate system
	 * 
	 * @param rectangle
	 * @return the converted rectangle
	 */
	public static Rectangle convertToScaled(Rectangle rectangle, double scaleFactor) {
		Rectangle newPoint = new Rectangle(convertToScaled(rectangle.x, scaleFactor), convertToScaled(rectangle.y,
				scaleFactor), convertToScaled(rectangle.width, scaleFactor), convertToScaled(rectangle.height,
				scaleFactor));
		return newPoint;
	}

	/**
	 * converts a point from the scaled coordinate system to the normalized
	 * coordinate system
	 * 
	 * @param rectangle
	 * @return the converted rectangle
	 */
	public static Point convertFromScaled(Point point, double scaleFactor) {
		Point newPoint = new Point(convertFromScaled(point.x, scaleFactor), convertFromScaled(point.y, scaleFactor));
		return newPoint;
	}

	/**
	 * converts a point from the normalized coordinate system to the scaled
	 * coordinate system
	 * 
	 * @param rectangle
	 * @return the converted rectangle
	 */
	public static Point convertToScaled(Point point, double scaleFactor) {
		Point newPoint = new Point(convertToScaled(point.x, scaleFactor), convertToScaled(point.y, scaleFactor));
		return newPoint;
	}

	/**
	 * converts a coordinate from the scaled coordinate system to the normalized
	 * coordinate system
	 * 
	 * @param rectangle
	 * @return the converted rectangle
	 */
	public static int convertFromScaled(int coordinate, double scaleFactor) {
		int newCoordinate = (int) Math.round((double) coordinate / scaleFactor);
		return newCoordinate;
	}

	/**
	 * converts a coordinate from the normalized coordinate system to the scaled
	 * coordinate system
	 * 
	 * @param rectangle
	 * @return the converted rectangle
	 */
	public static int convertToScaled(int coordinate, double scaleFactor) {
		int newCoordinate = (int) Math.round((double) coordinate * scaleFactor);
		return newCoordinate;
	}
}
