/**
 * 
 */
package com.wieseke.cptk.input.action;

import com.wieseke.cptk.input.constants.InputActionConstants;
import com.wieseke.cptk.input.viewer.InputCophylogenyViewer;
import com.wieseke.cptk.input.viewer.InputNodeControl;

/**
 * @author Nicolas Wieseke
 * 
 */
public class EditFoldNodeAction extends InputAction {

	/**
	 * default constructor
	 */
	public EditFoldNodeAction() {
		super(InputActionConstants.FOLD_NODE_TEXT);
	}

	/**
	 * constructor
	 * 
	 * @param viewer
	 * @param node
	 */
	public EditFoldNodeAction(InputCophylogenyViewer viewer,
			InputNodeControl node) {
		super(InputActionConstants.FOLD_NODE_TEXT);
		this.viewer = viewer;
		this.node = node;
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see org.eclipse.jface.action.Action#run()
	 */
	
	public void run() {
		if (this.node != null)
			this.node.toggleExpandFlag();
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see org.eclipse.jface.action.Action#setEnabled(boolean)
	 */
	
	public void setEnabled(boolean enabled) {
		if (enabled && node != null && !node.getNode().isLeaf()) {
			super.setEnabled(true);
		} else {
			super.setEnabled(false);
		}
	}
}