/**
 * 
 */
package com.wieseke.cptk.input.action;

import org.eclipse.jface.resource.ImageDescriptor;

import com.wieseke.cptk.app.CPTKApplication;
import com.wieseke.cptk.input.constants.InputActionConstants;

/**
 * @author Nicolas Wieseke
 * 
 */
public abstract class InputNodeControlActionFactory {

	// node actions
	public static final InputNodeControlActionFactory FOLD_NODE = new InputNodeControlActionFactory() {
		public InputAction create() {

			InputAction action = new EditFoldNodeAction();
			action.setId(InputActionConstants.FOLD_NODE_ID);
			action.setImageDescriptor(ImageDescriptor.createFromFile(
					CPTKApplication.class,
					InputActionConstants.FOLD_NODE_IMAGEPATH));
			action.setToolTipText(InputActionConstants.FOLD_NODE_TOOLTIPTEXT);
			return action;
		}
	};

	public static final InputNodeControlActionFactory ADD_NODE = new InputNodeControlActionFactory() {
		public InputAction create() {

			InputAction action = new EditAddNodeAction();
			action.setId(InputActionConstants.ADD_NODE_ID);
			action.setImageDescriptor(ImageDescriptor.createFromFile(
					CPTKApplication.class,
					InputActionConstants.ADD_NODE_IMAGEPATH));
			action.setToolTipText(InputActionConstants.ADD_NODE_TOOLTIPTEXT);
			return action;
		}
	};

	public static final InputNodeControlActionFactory DELETE_NODE = new InputNodeControlActionFactory() {
		public InputAction create() {

			InputAction action = new EditDeleteNodeAction();
			action.setId(InputActionConstants.DELETE_NODE_ID);
			action.setImageDescriptor(ImageDescriptor.createFromFile(
					CPTKApplication.class,
					InputActionConstants.DELETE_NODE_IMAGEPATH));
			action.setToolTipText(InputActionConstants.DELETE_NODE_TOOLTIPTEXT);
			return action;
		}
	};

	public static final InputNodeControlActionFactory CUT_SUBTREE = new InputNodeControlActionFactory() {
		public InputAction create() {

			InputAction action = new EditCutSubtreeAction();
			action.setId(InputActionConstants.CUT_SUBTREE_ID);
			action.setImageDescriptor(ImageDescriptor.createFromFile(
					CPTKApplication.class,
					InputActionConstants.CUT_SUBTREE_IMAGEPATH));
			action.setToolTipText(InputActionConstants.CUT_SUBTREE_TOOLTIPTEXT);
			return action;
		}
	};

	public static final InputNodeControlActionFactory CHANGE_LABEL = new InputNodeControlActionFactory() {
		public InputAction create() {

			InputAction action = new EditChangeLabelAction();
			action.setId(InputActionConstants.CHANGE_LABEL_ID);
			action.setImageDescriptor(ImageDescriptor.createFromFile(
					CPTKApplication.class,
					InputActionConstants.CHANGE_LABEL_IMAGEPATH));
			action
					.setToolTipText(InputActionConstants.CHANGE_LABEL_TOOLTIPTEXT);
			return action;
		}
	};

	public static final InputNodeControlActionFactory CHANGE_RANK = new InputNodeControlActionFactory() {
		public InputAction create() {

			InputAction action = new EditChangeRankAction();
			action.setId(InputActionConstants.CHANGE_RANK_ID);
			action.setImageDescriptor(ImageDescriptor.createFromFile(
					CPTKApplication.class,
					InputActionConstants.CHANGE_RANK_IMAGEPATH));
			action.setToolTipText(InputActionConstants.CHANGE_RANK_TOOLTIPTEXT);
			return action;
		}
	};

	public static final InputNodeControlActionFactory ADD_ASSOCIATION = new InputNodeControlActionFactory() {
		public InputAction create() {

			InputAction action = new EditAddAssociationAction();
			action.setId(InputActionConstants.ADD_ASSOCIATION_ID);
			action.setImageDescriptor(ImageDescriptor.createFromFile(
					CPTKApplication.class,
					InputActionConstants.ADD_ASSOCIATION_IMAGEPATH));
			action
					.setToolTipText(InputActionConstants.ADD_ASSOCIATION_TOOLTIPTEXT);
			return action;
		}
	};

	public static final InputNodeControlActionFactory DELETE_ASSOCIATIONS = new InputNodeControlActionFactory() {
		public InputAction create() {

			InputAction action = new EditDeleteAssociationsAction();
			action.setId(InputActionConstants.DELETE_ASSOCIATIONS_ID);
			action.setImageDescriptor(ImageDescriptor.createFromFile(
					CPTKApplication.class,
					InputActionConstants.DELETE_ASSOCIATIONS_IMAGEPATH));
			action
					.setToolTipText(InputActionConstants.DELETE_ASSOCIATIONS_TOOLTIPTEXT);
			return action;
		}
	};

	public static final InputNodeControlActionFactory REARRANGE_CHILD_POSITION = new InputNodeControlActionFactory() {
		public InputAction create() {

			InputAction action = new EditRearrangeChildPositionAction();
			action.setId(InputActionConstants.REARRANGE_CHILD_POSITION_ID);
			action.setImageDescriptor(ImageDescriptor.createFromFile(
					CPTKApplication.class,
					InputActionConstants.REARRANGE_CHILD_POSITION_IMAGEPATH));
			action
					.setToolTipText(InputActionConstants.REARRANGE_CHILD_POSITION_TOOLTIPTEXT);
			return action;
		}
	};

	public abstract InputAction create();
}
