/**
 * 
 */
package com.wieseke.cptk.input.action;

import org.eclipse.jface.util.IPropertyChangeListener;
import org.eclipse.jface.util.PropertyChangeEvent;

import com.wieseke.cptk.input.constants.InputViewerConstants;

/**
 * @author Nicolas Wieseke
 * 
 */
public class SelectTreeModeBothAction extends InputPropertyListenerAction {

	/**
	 * default constructor
	 * 
	 * @param text
	 */
	public SelectTreeModeBothAction(String text) {
		super(text, AS_RADIO_BUTTON);
		this.propertyChangeListener = new IPropertyChangeListener() {
			/*
			 * (non-Javadoc)
			 * 
			 * @see
			 * org.eclipse.jface.util.IPropertyChangeListener#propertyChange
			 * (org.eclipse.jface.util.PropertyChangeEvent)
			 */
			
			public void propertyChange(PropertyChangeEvent event) {
				if (event.getProperty().equals(
						InputViewerConstants.PROPERTY_TREE_MODE)
						&& !event.getNewValue().equals(event.getOldValue())) {
					setChecked((Integer) event.getNewValue() == InputViewerConstants.TREE_SELECTION_BOTH);
				}
			}
		};
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see org.eclipse.jface.action.Action#run()
	 */
	
	public void run() {
		if (this.viewer != null)
			getViewer().setTreeMode(InputViewerConstants.TREE_SELECTION_BOTH);
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see
	 * com.wieseke.cptk.input.action.InputPropertyListenerAction#selectionChanged
	 * (org.eclipse.ui.IWorkbenchPart, org.eclipse.jface.viewers.ISelection)
	 */
	
	public void selectionChanged(org.eclipse.ui.IWorkbenchPart part,
			org.eclipse.jface.viewers.ISelection selection) {
		super.selectionChanged(part, selection);
		if (this.viewer != null)
			setChecked((getViewer().getTreeMode() == InputViewerConstants.TREE_SELECTION_BOTH));

	}
}