/**
 * 
 */
package com.wieseke.cptk.input.model;

import java.util.Set;
import java.util.Map.Entry;

import com.wieseke.cptk.input.dao.InputCophylogeny;

/**
 * @author Nic
 * 
 */
public class InputCophylogenyProperties {

	private String filename;
	private String cospeciationCosts;
	private String sortingCosts;
	private String duplicationCosts;
	private String hostswitchCosts;
	private Set<Entry<String, String>> options;

	public InputCophylogenyProperties(InputCophylogeny cophylogeny) {
		this.filename = cophylogeny.getFilename();
		this.cospeciationCosts = cophylogeny.getCosts().getCospeciationCosts()
				.toPlainString();
		this.sortingCosts = cophylogeny.getCosts().getSortingCosts()
				.toPlainString();
		this.duplicationCosts = cophylogeny.getCosts().getDuplicationCosts()
				.toPlainString();
		this.hostswitchCosts = cophylogeny.getCosts().getHostswitchCosts()
				.toPlainString();
		this.options = cophylogeny.getOptions().entrySet();
	}

	/**
	 * @return the filename
	 */
	public String getFilename() {
		return filename;
	}

	/**
	 * @param filename
	 *            the filename to set
	 */
	public void setFilename(String filename) {
		this.filename = filename;
	}

	/**
	 * @return the cospeciationCosts
	 */
	public String getCospeciationCosts() {
		return cospeciationCosts;
	}

	/**
	 * @param cospeciationCosts
	 *            the cospeciationCosts to set
	 */
	public void setCospeciationCosts(String cospeciationCosts) {
		this.cospeciationCosts = cospeciationCosts;
	}

	/**
	 * @return the sortingCosts
	 */
	public String getSortingCosts() {
		return sortingCosts;
	}

	/**
	 * @param sortingCosts
	 *            the sortingCosts to set
	 */
	public void setSortingCosts(String sortingCosts) {
		this.sortingCosts = sortingCosts;
	}

	/**
	 * @return the duplicationCosts
	 */
	public String getDuplicationCosts() {
		return duplicationCosts;
	}

	/**
	 * @param duplicationCosts
	 *            the duplicationCosts to set
	 */
	public void setDuplicationCosts(String duplicationCosts) {
		this.duplicationCosts = duplicationCosts;
	}

	/**
	 * @return the hostswitchCosts
	 */
	public String getHostswitchCosts() {
		return hostswitchCosts;
	}

	/**
	 * @param hostswitchCosts
	 *            the hostswitchCosts to set
	 */
	public void setHostswitchCosts(String hostswitchCosts) {
		this.hostswitchCosts = hostswitchCosts;
	}

	/**
	 * @return the options
	 */
	public Set<Entry<String, String>> getOptions() {
		return options;
	}

	/**
	 * @param options
	 *            the options to set
	 */
	public void setOptions(Set<Entry<String, String>> options) {
		this.options = options;
	}

}
