/**
 * 
 */
package com.wieseke.cptk.input.preferences;

import org.eclipse.jface.preference.ColorFieldEditor;
import org.eclipse.jface.preference.FieldEditorPreferencePage;
import org.eclipse.jface.preference.IntegerFieldEditor;
import org.eclipse.jface.preference.RadioGroupFieldEditor;
import org.eclipse.ui.IWorkbench;
import org.eclipse.ui.IWorkbenchPreferencePage;
import org.eclipse.ui.PlatformUI;

/**
 * @author Nicolas Wieseke
 * 
 */
public class InputPreferencePage extends FieldEditorPreferencePage implements
		IWorkbenchPreferencePage {

	public InputPreferencePage() {
		super(GRID);
	}

	private RadioGroupFieldEditor lineType;
	private IntegerFieldEditor associationLineWidth;
	private ColorFieldEditor associationLineColor;
	private IntegerFieldEditor rearrangeNodesXDistance;
	private IntegerFieldEditor rearrangeNodesYDistance;
	private IntegerFieldEditor rearrangeTreeDistance;

	/*
	 * (non-Javadoc)
	 * 
	 * @see
	 * org.eclipse.jface.preference.FieldEditorPreferencePage#createFieldEditors
	 * ()
	 */
	
	protected void createFieldEditors() {
		String[][] labelAndValues = {
				{
						InputPreferenceConstants.INPUT_VIEWER_LINETYPE_RIGHT_ANGLED_TEXT,
						InputPreferenceConstants.INPUT_VIEWER_LINETYPE_RIGHT_ANGLED },
				{
						InputPreferenceConstants.INPUT_VIEWER_LINETYPE_ACUTE_ANGLED_TEXT,
						InputPreferenceConstants.INPUT_VIEWER_LINETYPE_ACUTE_ANGLED } };
		this.lineType = new RadioGroupFieldEditor(
				InputPreferenceConstants.INPUT_VIEWER_NAME_LINETYPE,
				InputPreferenceConstants.INPUT_VIEWER_LINETYPE_TEXT, 2,
				labelAndValues, getFieldEditorParent());
		addField(this.lineType);

		this.associationLineWidth = new IntegerFieldEditor(
				InputPreferenceConstants.INPUT_VIEWER_NAME_ASSOCIATION_LINEWIDTH,
				InputPreferenceConstants.INPUT_VIEWER_ASSOCIATION_LINEWIDTH_TEXT,
				getFieldEditorParent());
		addField(this.associationLineWidth);
		this.associationLineColor = new ColorFieldEditor(
				InputPreferenceConstants.INPUT_VIEWER_NAME_ASSOCIATION_LINECOLOR,
				InputPreferenceConstants.INPUT_VIEWER_ASSOCIATION_LINECOLOR_TEXT,
				getFieldEditorParent());
		addField(this.associationLineColor);

		this.rearrangeNodesXDistance = new IntegerFieldEditor(
				InputPreferenceConstants.INPUT_VIEWER_NAME_REARRANGE_NODES_XDISTANCE,
				InputPreferenceConstants.INPUT_VIEWER_REARRANGE_NODES_XDISTANCE_TEXT,
				getFieldEditorParent());
		addField(this.rearrangeNodesXDistance);
		this.rearrangeNodesYDistance = new IntegerFieldEditor(
				InputPreferenceConstants.INPUT_VIEWER_NAME_REARRANGE_NODES_YDISTANCE,
				InputPreferenceConstants.INPUT_VIEWER_REARRANGE_NODES_YDISTANCE_TEXT,
				getFieldEditorParent());
		addField(this.rearrangeNodesYDistance);
		this.rearrangeTreeDistance = new IntegerFieldEditor(
				InputPreferenceConstants.INPUT_VIEWER_NAME_REARRANGE_TREE_DISTANCE,
				InputPreferenceConstants.INPUT_VIEWER_REARRANGE_TREE_DISTANCE_TEXT,
				getFieldEditorParent());
		addField(this.rearrangeTreeDistance);
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see
	 * org.eclipse.ui.IWorkbenchPreferencePage#init(org.eclipse.ui.IWorkbench)
	 */
	
	public void init(IWorkbench workbench) {
		setPreferenceStore(PlatformUI.getPreferenceStore());
		setDescription("General preferences for visualizing input data");
	}

}
