/**
 * 
 */
package com.wieseke.cptk.input.wizards;

import org.eclipse.jface.wizard.WizardPage;
import org.eclipse.swt.SWT;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Spinner;

/**
 * @author Nicolas Wieseke
 * 
 */
public class ChangeHostRankWizardPage extends WizardPage {

	int oldValue;
	Spinner newValue;

	protected ChangeHostRankWizardPage(String pageName, int oldValue) {
		super(pageName);
		this.setTitle("Change timezone");
		this.setDescription("Enter the new timezone for the node.");
		this.oldValue = oldValue;
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see
	 * org.eclipse.jface.dialogs.IDialogPage#createControl(org.eclipse.swt.widgets
	 * .Composite)
	 */
	
	public void createControl(Composite parent) {
		Composite composite = new Composite(parent, SWT.FILL);
		GridLayout layout = new GridLayout(2, false);
		composite.setLayout(layout);
		Label label = new Label(composite, SWT.NONE);
		label.setText("Rank:");
		newValue = new Spinner(composite, SWT.BORDER);
		newValue.setMinimum(0);
		newValue.setMaximum(Integer.MAX_VALUE);
		GridData gridData = new GridData();
		gridData.horizontalAlignment = SWT.FILL;
		gridData.grabExcessHorizontalSpace = true;
		newValue.setLayoutData(gridData);
		newValue.setSelection(this.oldValue);
		setControl(composite);
	}

	public int getValue() {
		return newValue.getSelection();
	}

}
