/**
 * 
 */
package com.wieseke.cptk.input.wizards;

import java.io.ByteArrayInputStream;
import java.io.InputStream;

import org.eclipse.jface.viewers.IStructuredSelection;
import org.eclipse.ui.dialogs.WizardNewFileCreationPage;

import com.wieseke.cptk.common.exceptions.SerializeException;
import com.wieseke.cptk.input.dao.InputCophylogeny;
import com.wieseke.cptk.input.format.nexus.NexusSerializer;

/**
 * @author Nicolas Wieseke
 * 
 */
public class NewNexusFileWizardPage extends WizardNewFileCreationPage {

	public NewNexusFileWizardPage(IStructuredSelection selection) {
		super("WizardNewNexusFileCreationPage", selection);
		setTitle("Nexus File");
		setDescription("Creates a new Nexus File ressource");
		setFileExtension("nex");
	}

	
	protected InputStream getInitialContents() {
		InputCophylogeny cophylogeny = InputCophylogeny.createNewInputCophylogeny(getFileName());
		NexusSerializer serializer = new NexusSerializer();
		String str = "";
		try {
			str = serializer.serialize(cophylogeny);
		} catch (SerializeException e) {
		}
		return new ByteArrayInputStream(str.getBytes());
	}
}