/**
 * 
 */
package com.wieseke.cptk.input.wizards;

import java.io.ByteArrayInputStream;
import java.io.InputStream;

import org.eclipse.jface.viewers.IStructuredSelection;
import org.eclipse.ui.dialogs.WizardNewFileCreationPage;

import com.wieseke.cptk.common.exceptions.SerializeException;
import com.wieseke.cptk.input.dao.InputCophylogeny;
import com.wieseke.cptk.input.format.nexus.NexusSerializer;
import com.wieseke.cptk.statistics.CoevolutionSimulator;

/**
 * @author Nicolas Wieseke
 * 
 */
public class RandomSimulationNexusFileWizardPage extends
		WizardNewFileCreationPage {

	private RandomSimulationNexusFileWizardPage2 page2;

	public RandomSimulationNexusFileWizardPage(IStructuredSelection selection,
			RandomSimulationNexusFileWizardPage2 page2) {
		super("WizardRandomNexusFileCreationPage", selection);
		this.page2 = page2;
		setTitle("Random Simulation Nexus File");
		setDescription("Creates a Random Simulation Nexus File ressource");
		setFileExtension("nex");
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see
	 * org.eclipse.ui.dialogs.WizardNewFileCreationPage#getInitialContents()
	 */

	protected InputStream getInitialContents() {

		InputCophylogeny cophylogeny = null;
		cophylogeny = new CoevolutionSimulator(page2.getRandom(),
				page2.getCospeciationProbability(),
				page2.getSwitchingProbability(),
				page2.getHostChoosingProbability(),
				page2.isUseMergedNodeList(), page2.getModel(),
				page2.getPreferentialHostSwitchAlpha(),
				page2.getExtincrionProbability())
				.getSimulationInputCophylogeny(getFileName(),
						page2.getHostLeaves());

		NexusSerializer serializer = new NexusSerializer();
		String str = "";
		try {
			str = serializer.serialize(cophylogeny, false);
		} catch (SerializeException e) {
		}
		return new ByteArrayInputStream(str.getBytes());
	}
}