/**
 * 
 */
package com.wieseke.cptk.input.wizards;

import org.eclipse.jface.wizard.WizardPage;
import org.eclipse.swt.SWT;
import org.eclipse.swt.events.ModifyEvent;
import org.eclipse.swt.events.ModifyListener;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Combo;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Label;

/**
 * @author Nicolas Wieseke
 * 
 */
public class RearrangeChildPositionWizardPage extends WizardPage {

	String[] labels;
	Combo[] combos;

	protected RearrangeChildPositionWizardPage(String pageName, String[] labels) {
		super(pageName);
		this.setTitle("Rearrange child order");
		this.setDescription("Enter the new order of the child nodes.");
		this.labels = labels;
		this.combos = new Combo[labels.length];
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see
	 * org.eclipse.jface.dialogs.IDialogPage#createControl(org.eclipse.swt.widgets
	 * .Composite)
	 */
	
	public void createControl(Composite parent) {
		Composite composite = new Composite(parent, SWT.FILL);
		GridLayout layout = new GridLayout(2, false);
		composite.setLayout(layout);
		for (int i = 0; i < this.labels.length; i++) {
			Label label = new Label(composite, SWT.NONE);
			label.setText("Position " + (i + 1) + ":");
			combos[i] = new Combo(composite, SWT.READ_ONLY);
			GridData gridData = new GridData();
			// gridData.horizontalAlignment = SWT.FILL;
			// gridData.grabExcessHorizontalSpace = true;
			combos[i].setLayoutData(gridData);
			combos[i].setItems(this.labels);
			combos[i].select(i);
			combos[i].setData(i);
		}
		for (Combo combo : this.combos) {
			combo.addModifyListener(new ModifyListener() {
				
				public void modifyText(ModifyEvent e) {
					for (Combo other : combos) {
						if (!e.widget.equals(other)
								&& ((Combo) e.widget).getSelectionIndex() == other.getSelectionIndex()) {
							other.select((Integer) e.widget.getData());
						}
					}
					e.widget.setData(((Combo) e.widget).getSelectionIndex());
				}
			});
		}
		setControl(composite);
	}

	public int[] getValues() {
		int[] values = new int[this.combos.length];
		for (int i = 0; i < this.combos.length; i++) {
			values[i] = this.combos[i].getSelectionIndex();
		}
		return values;
	}

}
