/**
 * 
 */
package com.wieseke.cptk.output.action;

import org.eclipse.jface.resource.ImageDescriptor;

import com.wieseke.cptk.app.CPTKApplication;
import com.wieseke.cptk.output.constants.OutputActionConstants;

/**
 * @author Nicolas Wieseke
 * 
 */
public abstract class OutputCophylogenyViewerActionFactory {

	// node actions
	public static final OutputCophylogenyViewerActionFactory SELECT_FOLD_NODE = new OutputCophylogenyViewerActionFactory() {
		public OutputAction create() {

			String text = OutputActionConstants.FOLD_NODE_TEXT;
			OutputAction action = new SelectEditModeFoldNodeAction(text);
			action.setId(OutputActionConstants.FOLD_NODE_ID);
			action.setImageDescriptor(ImageDescriptor.createFromFile(
					CPTKApplication.class,
					OutputActionConstants.FOLD_NODE_IMAGEPATH));
			action.setToolTipText(OutputActionConstants.FOLD_NODE_TOOLTIPTEXT);
			return action;
		}
	};

	public static final OutputCophylogenyViewerActionFactory SELECT_CHANGE_LABEL = new OutputCophylogenyViewerActionFactory() {
		public OutputAction create() {

			String text = OutputActionConstants.CHANGE_LABEL_TEXT;
			OutputAction action = new SelectEditModeChangeLabelAction(text);
			action.setId(OutputActionConstants.CHANGE_LABEL_ID);
			action.setImageDescriptor(ImageDescriptor.createFromFile(
					CPTKApplication.class,
					OutputActionConstants.CHANGE_LABEL_IMAGEPATH));
			action
					.setToolTipText(OutputActionConstants.CHANGE_LABEL_TOOLTIPTEXT);
			return action;
		}
	};

	public static final OutputCophylogenyViewerActionFactory RECONSTRUCTION_NEXT = new OutputCophylogenyViewerActionFactory() {
		public OutputAction create() {

			String text = OutputActionConstants.RECONSTRUCTION_NEXT_TEXT;
			OutputAction action = new ReconstructionNextAction(text);
			action.setId(OutputActionConstants.RECONSTRUCTION_NEXT_ID);
			action.setImageDescriptor(ImageDescriptor.createFromFile(
					CPTKApplication.class,
					OutputActionConstants.RECONSTRUCTION_NEXT_IMAGEPATH));
			action
					.setToolTipText(OutputActionConstants.RECONSTRUCTION_NEXT_TOOLTIPTEXT);
			return action;
		}
	};

	public static final OutputCophylogenyViewerActionFactory RECONSTRUCTION_PREVIOUS = new OutputCophylogenyViewerActionFactory() {
		public OutputAction create() {

			String text = OutputActionConstants.RECONSTRUCTION_PREVIOUS_TEXT;
			OutputAction action = new ReconstructionPreviousAction(text);
			action.setId(OutputActionConstants.RECONSTRUCTION_PREVIOUS_ID);
			action.setImageDescriptor(ImageDescriptor.createFromFile(
					CPTKApplication.class,
					OutputActionConstants.RECONSTRUCTION_PREVIOUS_IMAGEPATH));
			action
					.setToolTipText(OutputActionConstants.RECONSTRUCTION_PREVIOUS_TOOLTIPTEXT);
			return action;
		}
	};

	public static final OutputCophylogenyViewerActionFactory RECONSTRUCTION_CHOOSE = new OutputCophylogenyViewerActionFactory() {
		public OutputAction create() {

			String text = OutputActionConstants.RECONSTRUCTION_CHOOSE_TEXT;
			OutputAction action = new ReconstructionChooseAction(text);
			action.setId(OutputActionConstants.RECONSTRUCTION_CHOOSE_ID);
			action.setImageDescriptor(ImageDescriptor.createFromFile(
					CPTKApplication.class,
					OutputActionConstants.RECONSTRUCTION_CHOOSE_IMAGEPATH));
			action.setToolTipText(OutputActionConstants.RECONSTRUCTION_CHOOSE_TOOLTIPTEXT);
			return action;
		}
	};

	public abstract OutputAction create();
}
