/**
 * 
 */
package com.wieseke.cptk.output.dao;

import java.util.ArrayList;
import java.util.List;

/**
 * @author Nic
 * 
 */
public class ChronologyNode {

	private ChronologyNode parent;
	private List<ChronologyNode> children;
	private boolean visited;
	public boolean isHostNode;

	/**
	 * default constructor
	 * 
	 * @param parent
	 */
	public ChronologyNode(ChronologyNode parent, boolean isHostNode) {
		this.parent = parent;
		this.children = new ArrayList<ChronologyNode>();
		this.visited = false;
		this.isHostNode = isHostNode;
	}

	/**
	 * get the parental node; the parental node is the ChronologyNode belonging
	 * to the parental node in the host or parasite tree
	 * 
	 * @return the parent
	 */
	public ChronologyNode getParent() {
		return parent;
	}

	/**
	 * adds a child node to the list of children
	 * 
	 * @param node
	 * @return true if the add operation was successful
	 */
	public boolean addChild(ChronologyNode node) {
		return this.children.add(node);
	}

	/**
	 * checks if the graph is acyclic
	 * 
	 * @return true if the graph is acyclic, otherwise false
	 */
	public boolean isAcyclic() {
		boolean isAcyclic = true;
		if (this.visited) {
			isAcyclic = false;
		} else {
			this.visited = true;
			for (ChronologyNode child : this.children) {
				if (!child.isAcyclic()) {
					isAcyclic = false;
					break;
				}
			}
		}
		this.visited = false;
		return isAcyclic;
	}

}