/**
 * 
 */
package com.wieseke.cptk.output.preferences;

import org.eclipse.core.runtime.preferences.AbstractPreferenceInitializer;
import org.eclipse.jface.preference.IPreferenceStore;
import org.eclipse.jface.preference.PreferenceConverter;
import org.eclipse.ui.PlatformUI;

/**
 * @author Nicolas Wieseke
 * 
 */
public class OutputPreferenceInitializer extends AbstractPreferenceInitializer {

	public OutputPreferenceInitializer() {
		super();
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @seeorg.eclipse.core.runtime.preferences.AbstractPreferenceInitializer#
	 * initializeDefaultPreferences()
	 */
	
	public void initializeDefaultPreferences() {
		IPreferenceStore store = PlatformUI.getPreferenceStore();
		store.setDefault(OutputPreferenceConstants.OUTPUT_VIEWER_NAME_LINETYPE,
				OutputPreferenceConstants.OUTPUT_VIEWER_LINETYPE);
		store
				.setDefault(
						OutputPreferenceConstants.OUTPUT_VIEWER_NAME_REARRANGE_NODES_XDISTANCE,
						OutputPreferenceConstants.OUTPUT_VIEWER_REARRANGE_NODES_XDISTANCE);
		store
				.setDefault(
						OutputPreferenceConstants.OUTPUT_VIEWER_NAME_REARRANGE_NODES_YDISTANCE,
						OutputPreferenceConstants.OUTPUT_VIEWER_REARRANGE_NODES_YDISTANCE);
		store
				.setDefault(
						OutputPreferenceConstants.OUTPUT_VIEWER_NAME_PARASITE_SHIFT_XDISTANCE,
						OutputPreferenceConstants.OUTPUT_VIEWER_PARASITE_SHIFT_XDISTANCE);
		store
				.setDefault(
						OutputPreferenceConstants.OUTPUT_VIEWER_NAME_PARASITE_SHIFT_YDISTANCE,
						OutputPreferenceConstants.OUTPUT_VIEWER_PARASITE_SHIFT_YDISTANCE);

		store.setDefault(
				OutputPreferenceConstants.OUTPUT_VIEWER_NAME_HOST_LINEWIDTH,
				OutputPreferenceConstants.OUTPUT_VIEWER_HOST_LINEWIDTH);
		store.setDefault(
				OutputPreferenceConstants.OUTPUT_VIEWER_NAME_HOST_NODEWIDTH,
				OutputPreferenceConstants.OUTPUT_VIEWER_HOST_NODEWIDTH);
		store.setDefault(
				OutputPreferenceConstants.OUTPUT_VIEWER_NAME_HOST_NODEHEIGHT,
				OutputPreferenceConstants.OUTPUT_VIEWER_HOST_NODEHEIGHT);
		PreferenceConverter.setDefault(store,
				OutputPreferenceConstants.OUTPUT_VIEWER_NAME_HOST_LINECOLOR,
				OutputPreferenceConstants.OUTPUT_VIEWER_HOST_LINECOLOR);
		PreferenceConverter.setDefault(store,
				OutputPreferenceConstants.OUTPUT_VIEWER_NAME_HOST_NODECOLOR,
				OutputPreferenceConstants.OUTPUT_VIEWER_HOST_NODECOLOR);
		PreferenceConverter
				.setDefault(
						store,
						OutputPreferenceConstants.OUTPUT_VIEWER_NAME_HOST_NODEOUTLINECOLOR,
						OutputPreferenceConstants.OUTPUT_VIEWER_HOST_NODEOUTLINECOLOR);
		PreferenceConverter
				.setDefault(
						store,
						OutputPreferenceConstants.OUTPUT_VIEWER_NAME_HOST_NODEHIGHLIGHTCOLOR,
						OutputPreferenceConstants.OUTPUT_VIEWER_HOST_NODEHIGHLIGHTCOLOR);
		PreferenceConverter
				.setDefault(
						store,
						OutputPreferenceConstants.OUTPUT_VIEWER_NAME_HOST_NODEFOLDSIGNCOLOR,
						OutputPreferenceConstants.OUTPUT_VIEWER_HOST_NODEFOLDSIGNCOLOR);
		PreferenceConverter.setDefault(store,
				OutputPreferenceConstants.OUTPUT_VIEWER_NAME_HOST_FONTCOLOR,
				OutputPreferenceConstants.OUTPUT_VIEWER_HOST_FONTCOLOR);
		PreferenceConverter.setDefault(store,
				OutputPreferenceConstants.OUTPUT_VIEWER_NAME_HOST_FONT,
				OutputPreferenceConstants.OUTPUT_VIEWER_HOST_FONT);

		store
				.setDefault(
						OutputPreferenceConstants.OUTPUT_VIEWER_NAME_PARASITE_LINEWIDTH,
						OutputPreferenceConstants.OUTPUT_VIEWER_PARASITE_LINEWIDTH);
		store
				.setDefault(
						OutputPreferenceConstants.OUTPUT_VIEWER_NAME_PARASITE_NODEWIDTH,
						OutputPreferenceConstants.OUTPUT_VIEWER_PARASITE_NODEWIDTH);
		store
				.setDefault(
						OutputPreferenceConstants.OUTPUT_VIEWER_NAME_PARASITE_NODEHEIGHT,
						OutputPreferenceConstants.OUTPUT_VIEWER_PARASITE_NODEHEIGHT);
		PreferenceConverter
				.setDefault(
						store,
						OutputPreferenceConstants.OUTPUT_VIEWER_NAME_PARASITE_LINECOLOR,
						OutputPreferenceConstants.OUTPUT_VIEWER_PARASITE_LINECOLOR);
		PreferenceConverter
				.setDefault(
						store,
						OutputPreferenceConstants.OUTPUT_VIEWER_NAME_PARASITE_NODECOLOR,
						OutputPreferenceConstants.OUTPUT_VIEWER_PARASITE_NODECOLOR);
		PreferenceConverter
				.setDefault(
						store,
						OutputPreferenceConstants.OUTPUT_VIEWER_NAME_PARASITE_NODEOUTLINECOLOR,
						OutputPreferenceConstants.OUTPUT_VIEWER_PARASITE_NODEOUTLINECOLOR);
		PreferenceConverter
				.setDefault(
						store,
						OutputPreferenceConstants.OUTPUT_VIEWER_NAME_PARASITE_NODEHIGHLIGHTCOLOR,
						OutputPreferenceConstants.OUTPUT_VIEWER_PARASITE_NODEHIGHLIGHTCOLOR);
		PreferenceConverter
				.setDefault(
						store,
						OutputPreferenceConstants.OUTPUT_VIEWER_NAME_PARASITE_NODEFOLDSIGNCOLOR,
						OutputPreferenceConstants.OUTPUT_VIEWER_PARASITE_NODEFOLDSIGNCOLOR);
		PreferenceConverter
				.setDefault(
						store,
						OutputPreferenceConstants.OUTPUT_VIEWER_NAME_PARASITE_FONTCOLOR,
						OutputPreferenceConstants.OUTPUT_VIEWER_PARASITE_FONTCOLOR);
		PreferenceConverter.setDefault(store,
				OutputPreferenceConstants.OUTPUT_VIEWER_NAME_PARASITE_FONT,
				OutputPreferenceConstants.OUTPUT_VIEWER_PARASITE_FONT);
	}
}
