/**
 * 
 */
package com.wieseke.cptk.output.viewer;

import org.eclipse.jface.preference.IPreferenceStore;
import org.eclipse.jface.preference.PreferenceConverter;
import org.eclipse.swt.graphics.Color;
import org.eclipse.swt.widgets.Display;
import org.eclipse.ui.PlatformUI;

import com.wieseke.cptk.common.api.IPositionNode;
import com.wieseke.cptk.common.viewer.CophylogenyViewer;
import com.wieseke.cptk.common.viewer.NodeControl;
import com.wieseke.cptk.output.dao.OutputHostNode;
import com.wieseke.cptk.output.preferences.OutputPreferenceConstants;

/**
 * @author Nicolas Wieseke
 * 
 */
public class OutputHostNodeControl extends OutputNodeControl {

	/**
	 * default constructor
	 * 
	 * @param viewer
	 * @param node
	 * @param parent
	 */
	public OutputHostNodeControl(CophylogenyViewer viewer, IPositionNode node,
			NodeControl parent) {
		super(viewer, node, parent);
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see com.wieseke.cptk.input.view.swt.InputNodeCanvas#init()
	 */

	protected void init() {
		IPreferenceStore store = PlatformUI.getPreferenceStore();
		this.width = store
				.getInt(OutputPreferenceConstants.OUTPUT_VIEWER_NAME_HOST_NODEWIDTH);
		this.height = store
				.getInt(OutputPreferenceConstants.OUTPUT_VIEWER_NAME_HOST_NODEHEIGHT);
		this.foldSignColor = new Color(
				Display.getDefault(),
				PreferenceConverter
						.getColor(
								store,
								OutputPreferenceConstants.OUTPUT_VIEWER_NAME_HOST_NODEFOLDSIGNCOLOR));
		this.nodeColor = new Color(
				Display.getDefault(),
				PreferenceConverter
						.getColor(
								store,
								OutputPreferenceConstants.OUTPUT_VIEWER_NAME_HOST_NODECOLOR));
		this.nodeHighlightColor = new Color(
				Display.getDefault(),
				PreferenceConverter
						.getColor(
								store,
								OutputPreferenceConstants.OUTPUT_VIEWER_NAME_HOST_NODEHIGHLIGHTCOLOR));
		this.nodeOutlineColor = new Color(
				Display.getDefault(),
				PreferenceConverter
						.getColor(
								store,
								OutputPreferenceConstants.OUTPUT_VIEWER_NAME_HOST_NODEOUTLINECOLOR));
	}

	public OutputHostNode getNode() {
		return (OutputHostNode) super.getNode();
	}

}
