/**
 * 
 */
package com.wieseke.cptk.output.wizards;

import org.eclipse.jface.wizard.WizardPage;
import org.eclipse.swt.SWT;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Text;

/**
 * @author Nicolas Wieseke
 * 
 */
public class ChangeLabelWizardPage extends WizardPage {

	String oldLabel;
	Text newLabel;

	protected ChangeLabelWizardPage(String pageName, String label) {
		super(pageName);
		this.setTitle("Change label");
		this.setDescription("Enter the new label for the node.");
		this.oldLabel = label;
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see
	 * org.eclipse.jface.dialogs.IDialogPage#createControl(org.eclipse.swt.widgets
	 * .Composite)
	 */
	
	public void createControl(Composite parent) {
		Composite composite = new Composite(parent, SWT.FILL);
		GridLayout layout = new GridLayout(2, false);
		composite.setLayout(layout);
		Label name = new Label(composite, SWT.NONE);
		name.setText("Label:");
		newLabel = new Text(composite, SWT.BORDER);
		GridData gridData = new GridData();
		gridData.horizontalAlignment = SWT.FILL;
		gridData.grabExcessHorizontalSpace = true;
		newLabel.setLayoutData(gridData);
		newLabel.setText(this.oldLabel);
		newLabel.selectAll();
		setControl(composite);
	}

	public String getLabel() {
		return newLabel.getText().replaceAll("\\s", "_");
	}

}
