/**
 * 
 */
package com.wieseke.cptk.reconstruction.dao;

import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.List;

/**
 * @author Nicolas Wieseke
 * 
 */
public class ReconstructionInfo {

	/**
	 * the host index
	 */
	private Integer hostIndex;
	/**
	 * the parasite index
	 */
	private Integer parasiteIndex;
	/**
	 * the costs for the whole reconstruction
	 */
	private BigDecimal costs;
	/**
	 * list of reconstructions possibilities (having all the minimal costs)
	 */
	private List<ReconstructionElement> reconstructions;

	public ReconstructionInfo(Integer parasiteIndex) {
		this.parasiteIndex = parasiteIndex;
		this.hostIndex = -1;
		this.costs = null;
		this.reconstructions = new ArrayList<ReconstructionElement>();
	}

	public ReconstructionInfo(Integer parasiteIndex, Integer hostIndex,
			BigDecimal costs) {
		this.parasiteIndex = parasiteIndex;
		this.hostIndex = hostIndex;
		this.costs = costs;
		this.reconstructions = new ArrayList<ReconstructionElement>();
	}

	/**
	 * @return the hostIndex
	 */
	public Integer getHostIndex() {
		return hostIndex;
	}

	/**
	 * @return the parasiteIndex
	 */
	public Integer getParasiteIndex() {
		return parasiteIndex;
	}

	/**
	 * @param hostIndex
	 *            the hostIndex to set
	 */
	public void setHostIndex(Integer hostIndex) {
		this.hostIndex = hostIndex;
	}

	/**
	 * @return the costs
	 */
	public BigDecimal getCosts() {
		return costs;
	}

	/**
	 * @param costs
	 *            the costs to set
	 */
	public void setCosts(BigDecimal costs) {
		this.costs = costs;
	}

	/**
	 * @return the reconstructions
	 */
	public List<ReconstructionElement> getReconstructions() {
		return reconstructions;
	}

	/**
	 * @param reconstructions
	 *            the reconstructions to set
	 */
	public void setReconstructions(List<ReconstructionElement> reconstructions) {
		this.reconstructions = reconstructions;
	}

	public String toString() {
		if (this.costs == null)
			return "null";
		return this.costs.toString();
	}
}
